Subject: New diff test failures on s390x architecture (was: [ANNOUNCE] Git v2.22.0-rc1)

From: Todd Zullinger <[email-masked]>
Date: Thu, 23 May 2019 11:04:16 -0400

[-cc: lkml, +cc: Duy as author of a good number of
diff-related commits in 2.22.0 :) ]

Hi,

While running the 2.22.0-rc1 tests on Fedora, I hit a few
new test failures since 2.21.0 -- but only on the s390x
architecture.

I haven't had time to dig into these the past few days, so I
thought I would send what I do have in case the problem is
obvious to someone else.  I think all of the failing tests
are due to `git diff` commands.

Test Summary Report
-------------------
t4017-diff-retval.sh                             (Wstat: 256 Tests: 24 Failed: 1)
  Failed test:  2
  Non-zero exit status: 1
t4015-diff-whitespace.sh                         (Wstat: 256 Tests: 83 Failed: 11)
  Failed tests:  2-7, 9, 11, 52-53, 79
  Non-zero exit status: 1
t4035-diff-quiet.sh                              (Wstat: 256 Tests: 22 Failed: 4)
  Failed tests:  17-20
  Non-zero exit status: 1
t4040-whitespace-status.sh                       (Wstat: 256 Tests: 11 Failed: 4)
  Failed tests:  3, 5, 7, 9
  Non-zero exit status: 1
t4038-diff-combined.sh                           (Wstat: 256 Tests: 24 Failed: 3)
  Failed tests:  10-12
  Non-zero exit status: 1
t4050-diff-histogram.sh                          (Wstat: 256 Tests: 3 Failed: 1)
  Failed test:  1
  Non-zero exit status: 1
t4061-diff-indent.sh                             (Wstat: 256 Tests: 33 Failed: 19)
  Failed tests:  2-4, 8, 12, 14, 18, 20-21, 24-33
  Non-zero exit status: 1
t4065-diff-anchored.sh                           (Wstat: 256 Tests: 7 Failed: 1)
  Failed test:  6
  Non-zero exit status: 1
t4253-am-keep-cr-dos.sh                          (Wstat: 256 Tests: 7 Failed: 1)
  Failed test:  7
  Non-zero exit status: 1

The test output from '-x --verbose-log' is quite verbose and
the issues are often in whitespace/end-of-line which might
be mangled by some MTA/MUA.  So the output is at:

    https://tmz.fedorapeople.org/git-2.22.0-rc1-s390x-failures (327K)

I don't have direct access to these s390x builders.  I may
be able to arrange shell access (or even reproduce this with
qemu's s390x emulation).

Before I go further down that road, I wanted to see if this
output might be enough to point to the problem.  If not, I
can run the failing tests with the --debug option and save
the trash directory (unless I can get more direct access to
the s390x builder to be able to bisect).

I rebuilt git-2.21.0 on the same s390x builder successfully,
so I don't think this issue is a bug in another of the
packages in the current Fedora tree.  But it's certainly
possible that git-2.22.0-rc1 is just tickling a real bug in
some other tool/library on s390x.

Thanks for any help in narrowing this down.

-- 
Todd